package tmpl_test

import (
	"bytes"
	"testing"

	"github.com/stretchr/testify/require"

	"gitlab.com/pjrpc/pjrpc/cmd/genpjrpc/generator/printer/tmpl"
)

func TestExecHeaderGoFile(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.HeaderGoFileData{
		Version: "123",
		Package: "pkgname",
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecHeaderGoFile(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(
		`// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: 123

package pkgname

`,
	)

	data.Version = ""
	testCase(
		`// Code generated by genpjrpc. DO NOT EDIT.

package pkgname

`,
	)

	data.Tags = "go:build !js && !wasm"
	testCase(
		`// Code generated by genpjrpc. DO NOT EDIT.
//go:build !js && !wasm

package pkgname

`,
	)

	data.Tags = "go:build !js && !wasm"
	data.Version = "v1.0.0"
	testCase(
		`// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v1.0.0
//go:build !js && !wasm

package pkgname

`,
	)
}

func TestExecMethodConstantName(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.MethodConstantNameData{
		GoServiceName: "",
		GoMethodName:  "MethodName",
		ConstSuffix:   "",
	}

	testCase := func(want string) {
		got := tmpl.ExecMethodConstantName(data)
		so.Equal(want, got)
	}

	testCase("JSONRPCMethodMethodName")

	data.ConstSuffix = "Client"
	testCase("JSONRPCMethodMethodNameClient")

	data.ConstSuffix = ""
	data.GoServiceName = "ServiceName"

	testCase("JSONRPCMethodServiceNameMethodName")
}

func TestExecMethodConstantValue(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.MethodConstantValueData{
		JRPCMethodName: "method_name",
	}

	testCase := func(want string) {
		got := tmpl.ExecMethodConstantValue(data)
		so.Equal(want, got)
	}

	testCase("method_name")

	data.JRPCServiceName = "service_name"
	testCase("service_name_method_name")
}

func TestExecInterfaceMethod(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.InterfaceMethodData{
		MethodName:  "Method",
		ContextType: "context.Context",
		InType:      "pkg.InType",
		OutType:     "pkg.OutType",
	}

	testCase := func(want string) {
		got := tmpl.ExecInterfaceMethod(data)
		so.Equal(want, got)
	}

	testCase("Method(ctx context.Context, in pkg.InType) ( pkg.OutType,  error)")

	data.ModType = "client.Mod"
	data.ResultName = "result"
	data.ErrName = "err"
	testCase("Method(ctx context.Context, in pkg.InType, mods ...client.Mod) (result pkg.OutType, err error)")

	data.InIsPointer = true
	data.OutIsPointer = true
	testCase("Method(ctx context.Context, in *pkg.InType, mods ...client.Mod) (result *pkg.OutType, err error)")
}

func TestExecServerRegType(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.ServerRegTypeData{
		RegTypeName:   "reg_Service",
		InterfaceName: "ServiceServer",
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecServerRegType(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(`type reg_Service struct {
	svc ServiceServer
}

`)
}

func TestExecServerRegFuncTmpl(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.ServerRegFuncData{
		FuncName:       "RegisterServiceServer",
		SType:          "pjrpc.Registrator",
		InterfaceName:  "ServiceServer",
		MiddlewareType: "pjrpc.Middleware",
		RegTypeName:    "reg_Service",
		Methods: []*tmpl.ServerRegFuncDataMethod{
			{ConstantName: "JSONRPCMethodMethodName", RegFuncName: "regMethodName"},
			{ConstantName: "JSONRPCMethodSomeWork", RegFuncName: "regSomeWork"},
		},
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecServerRegFuncTmpl(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(`// RegisterServiceServer registers rpc handlers with middlewares in the server router.
func RegisterServiceServer(srv pjrpc.Registrator, svc ServiceServer, middlewares ...pjrpc.Middleware) {
	r := &reg_Service{svc: svc}

	srv.RegisterMethod(JSONRPCMethodMethodName, r.regMethodName)
	srv.RegisterMethod(JSONRPCMethodSomeWork, r.regSomeWork)

	srv.With(middlewares...)
}

`)
}

func TestExecServerRegMethodTmpl(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.ServerRegMethodData{
		RegTypeName: "reg_Service",
		RegFuncName: "regMethodName",
		ContextType: "context.Context",
		JSONParams:  "json.RawMessage",
		InType:      "pkg.InType",
		InIsPointer: true,
		PJSONMethod: "pjson.Unmarshal",
		JerrsMethod: "pjrpc.JRPCErrParseError",
		MethodName:  "MethodName",
		FmtErrorf:   "fmt.Errorf",
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecServerRegMethodTmpl(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(`func (r *reg_Service) regMethodName(ctx context.Context, params json.RawMessage) (interface{}, error) {
	in := new(pkg.InType)
	if params != nil {
		if err := pjson.Unmarshal(params, in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.MethodName(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed MethodName: %w", err)
	}

	return res, nil
}

`)

	data.InIsPointer = false
	testCase(`func (r *reg_Service) regMethodName(ctx context.Context, params json.RawMessage) (interface{}, error) {
	var in pkg.InType
	if params != nil {
		if err := pjson.Unmarshal(params, &in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.MethodName(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed MethodName: %w", err)
	}

	return res, nil
}

`)
}

func TestExecClientImplementorTmpl(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.ClientImplementorData{
		Implementor:   "implServiceClient",
		InvokerType:   "client.Invoker",
		InterfaceName: "ServiceClient",
		ServiceName:   "Service",
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecClientImplementorTmpl(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(`type implServiceClient struct {
	cl client.Invoker
}

// NewServiceClient returns new client implementation of the Service service.
func NewServiceClient(cl client.Invoker) ServiceClient {
	return &implServiceClient{cl: cl}
}

`)
}

func TestExecClientImplementorMethodTmpl(t *testing.T) {
	t.Parallel()
	so := require.New(t)

	data := &tmpl.ClientImplementorMethodData{
		Implementor:  "implServiceClient",
		MethodFunc:   "Method(ctx context.Context, in *pkg.InType, mods ...client.Mod) (result *pkg.OutType, err error)",
		ResultVar:    "result",
		UUIDFunc:     "uuid.NewUUID",
		FmtErrorf:    "fmt.Errorf",
		OutType:      "pkg.OutType",
		OutIsPointer: true,
		ConstantName: "JSONRPCMethodMethod",
	}

	testCase := func(want string) {
		buf := new(bytes.Buffer)
		tmpl.ExecClientImplementorMethodTmpl(buf, data)
		so.Equal(want, buf.String())
	}

	testCase(`func (c *implServiceClient) Method(ctx context.Context, in *pkg.InType, mods ...client.Mod) (result *pkg.OutType, err error) {
	gen, err := uuid.NewUUID()
	if err != nil {
		return result, fmt.Errorf("failed to create uuid generator: %w", err)
	}

	err = c.cl.Invoke(ctx, gen.String(), JSONRPCMethodMethod, in, &result, mods...)
	if err != nil {
		return result, fmt.Errorf("failed to Invoke method %q: %w", JSONRPCMethodMethod, err)
	}

	return result, nil
}

`)

	data.MethodFunc = "Method(ctx context.Context, in pkg.InType, mods ...client.Mod) (result pkg.OutType, err error)"
	data.OutIsPointer = false

	testCase(`func (c *implServiceClient) Method(ctx context.Context, in pkg.InType, mods ...client.Mod) (result pkg.OutType, err error) {
	gen, err := uuid.NewUUID()
	if err != nil {
		return result, fmt.Errorf("failed to create uuid generator: %w", err)
	}

	err = c.cl.Invoke(ctx, gen.String(), JSONRPCMethodMethod, in, &result, mods...)
	if err != nil {
		return result, fmt.Errorf("failed to Invoke method %q: %w", JSONRPCMethodMethod, err)
	}

	return result, nil
}

`)
}
